/* A forum  script for SRE-http -- for multi threaded "news group"
manipulation of messages boxes. */

forum:

parse arg  ddir, tempfile, reqstrg,list,verb ,uri,user, ,
          basedir ,workdir,privset,enmadd,transaction,verbose, ,
         servername,host_nickname,homedir


if verb="" then do
    Say " This is NOT designed to be run in stand-alone mode. "
   say  " It is used by SRE-http as an external procedure! "
   exit
end  /* Do */


do_determine_order=1           /* set to 0 to suppress "jump to
                                   next message" options (might speed
                                things up if you set to 0 */
              

parse upper version  rexxtype .

/* ============== View a message box */
  if do_htaccess==1 then do
         yowb=get_value('ADDON_DIR')
         aa=strip(yowb,'t','\')||'\'

/* depending on version, use macrospace or not */
        if rexxtype="OBJREXX" then   /* object rexx, use file version */
            tmp1=htaccess(sel,aa,htaccess_file, ,
                    user,,,serverport,ddir,,TEMPFILE,0)
         else
            tmp1=sref_htaccess(sel,aa,htaccess_file, ,
                    user,,,serverport,ddir,,TEMPFILE,0)
          if tmp1=-1 then return '400 0 FORUM Access not permitted '
   end
   messbox_dir=value(enmadd||'MESSBOX_DIR',,'os2environment')
   messbox_dir=strip(messbox_dir,'t','\')

   ABOX=' '
   dog=vumessage(list)
 
/* now, clean up message box */
   return  dog


/* ---- Spiffize a message box file, and give responsdent an
opportunity to choose which message to view */

vumessage:procedure expose  enmadd  tempfile messbox_dir verbose uri servername all_password ,
                        privset ABOX do_determine_order

seperator='!===============1x2y3z4a5b6c7d8e9f0g9h8i7j6k5l4m3n2o1===========!'
refresh_idx=0 ; dodelete=0
used_index=0

order_list.doit2it=do_determine_order

parse arg list

/**  parse out the arguments sent by the requester -- store in VARS stem */

a=parse_vars(list)
abox=vars.messagebox

/* check to see if client has access rights to this forum */
okay=0
do iu=1 to words(privset)
  aww=strip(upper(word(privset,iu)))
  if  aww="SUPERUSER" then do
     okay=1
     leave
  end
  if abbrev(aww,'MESSBOX=')=0 & abbrev(aww,'MESSBOX:')=0 then iterate
/* a forum entry -- does it match this forum? */
  AWW=SUBSTR(AWW,9)               /*DROP MESSBOX= HEADER*/
  OKAY=sref_wildcard(abox,AWW,0)
  parse var okay okay .
  IF OKAY>0 THEN LEAVE
END
if okay=0 then do       /* not allowed access to this forum */
     foo=ASK_AUTH('Access_to_message_box_'||abox)
     return foo
end


/** check for existense of desired message box */

thefile=messbox_dir||"\"||abox||".LOG" ; 
ause=sysfiletree(thefile,'thefileinfo','T')
if thefileinfo.0=0 | ause<>0 then do
  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

  call lineout tempfile, "<html><head><title>Messages Can Not Be Viewed</title></head>"
  call lineout tempfile, "<body>"
  call lineout tempfile, "<h2>Could not view message box </h2>"
  call lineout tempfile, " Could not find the " abox " message box. <hr>"
  call lineout tempfile,'<a href="/" rel="Parent"> Return to home page </a>'
  call lineout tempfile, "<hr></body></html>"
  call lineout tempfile
 return 'FILE erase  TYPE text/html nocache NAME '||tempfile
end

thefilesize=chars(thefile)
foo=stream(thefile,'c','close')


/*  simplest reponse == show the entire file -- must have VIEWMESS privileges */
if vars.listall=1 then do
   if wordpos('VIEWMESS',upper(privset))=0 & wordpos('SUPERUSER',upper(privset))=0 then do
          eek=responseff('unauth','Not allowed to view contents of:'||thefile,tempfile,servername)
          return eek
   end
   aa=do_fixexpire(thefile)
   return 'FILE TYPE text/plain nocache NAME ' thefile
end


/*****  otherwise, use a "threaded-selectable" list */
call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
call lineout tempfile, "<html><head><title>Viewing the " vars.messagebox " message box</title></head>"
call lineout tempfile, "<body>"


/* Special cases: if simple request to view list of messages,
with no fields specified, then see if saved index can be used! */
if vars.deleteme=1 then signal noindex
if vars.fieldlist<>' '  then signal noindex  /* not that abstract can be used*/

/* if here, try the index */
 theidx=messbox_dir||"\"||abox||".IDX"
 wow=sysfiletree(theidx,idxinfo,'T')
 if wow<>0 | idxinfo.0=0 then do
       refresh_idx=1
       signal noindex
   end
 parse var idxinfo.1 idxdate . ; idxdate=translate(idxdate,'$','/')
 parse var thefileinfo.1 logdate . ; logdate=translate(logdate,'$','/')
/* if log file newer then idx file, can't use it */
 if  idxdate  < logdate then do
        refresh_idx=1           /* need to update index file */
        signal noindex
 end
/* if here, grab the messindx from the idx file -- using rexxlib's
                                       "stem var to file" routine */
 foo=cvread(theidx,'messindx')
 if foo=0 then do
       refresh_idx=1           /* need to recreate index file */
       signal noindex
  end
                                   
/* double check: is file size correct? */
  if messindx.filesize<>thefilesize then do
        say " Index file too old " messindx.filesize
       aa=stream(thefile,'c','close')
       refresh_idx=1
       signal noindex
  end

 nummess=messindx.nmessages       /* ready to show "abstracts */
 nummess_ok=messindx.nmessagesok       /* ready to show "abstracts */
 do ii=1 to nummess
      messindx.ii.wrote=0
      messindx.ii.order=0
 end /* do */

 header_end=messindx.headerend

/* determine order of messages? */
if do_determine_order=1 then do
   foo=determine_order(' ')               /* adds messindx.n.order value */
end  /* Do */


nmu=0
if vars.messageid<>0  then do     /* search for matching message id */
   do iu=1 to nummess
      if messindx.iu.messageid=vars.messageid then do
           nmu=iu
           leave
      end
   end /* do */
   if nmu>0 then do             /* read file, and display the message indexed by nmu */
       foo=fileread(thefile,filelines,,)
       aa=write_block(NMU,0,'<br>')
       signal talmost_done
   end  /* Do */
   else do              /* no matchind id */
      foo=no_messageid()
      return foo
   end  /* Do */
end  /* Do */


foo=write_out_header(thefile,header_end,tempfile)

 call lineout tempfile,' <hr> <h3> <center>' nummess_ok' messages in this discussion list </center> </h3>  '
 messindx.fromindex=1
 messindx.order=0
 wow=write_thread(' ',1)   /* ' ' signals: all threads */


if verbose>1 then say " FORUM: using " theidx " index  file "
 call lineout tempfile,' <hr> '
 if vars.form<>' ' then do
           call lineout tempfile,' <li> Do you want to  <a href="'||vars.form||'">add a message?</a>'
 end
 if  vars.doabstract=0  then do
         call lineout tempfile,'<li><a href="/'||uri||'&abstract=yes"> Display an abstract of each message?</a>'
  end  /* Do */
 
if dodelete>0 then do
       refresh_idx=1
       foo=fileread(thefile,filelines,,)
 end

 used_index=1

 signal talmost_done

/* USE index to display results ----------  Special case */

/*** IF here, CREATE an index (can not use current one ******/
noindex: nop        /* jump here if could not do index display */

foo=fileread(thefile,filelines,,)

/** see if there is a header.  Defined as the stuff before the
first message, where messages are delimited by the SEPERATOR
string (or eof). This should probably be HTML code describing the
message box */

header_end=filelines.0
do mm=1 to filelines.0
   if strip(filelines.mm)=seperator & header_end=filelines.0 then
                header_end=mm
   filelines.mm=translate(filelines.mm,' ','1a00'x)
end /* do */

ok1=0
do mm0=1 to header_end-1
   if filelines.mm0<>' ' then ok1=1
   call lineout tempfile,filelines.mm0
end

if ok1=0  then    do      /* generic header needed? */
   call lineout tempfile,' <h1> This is the  ' vars.messagebox ' message box. </h1>'
end

/* create an index of the message blocks */
nummess1=build_index(header_end,thefilesize)

messindx.fromindex=0                     
parse var nummess1  nummess nummess_ok   
                                         

/* determine order of messages? */
if nummess_ok>0 & do_determine_order=1 then do
   foo=determine_order(' ')
end  /* Do */

/* now process request */
select
   when vars.deleteme=1 then do                 /* delete a message? */
     do ik=1 to nummess
       if vars.password=' ' then leave
       if upper(vars.messageid)=upper(messindx.ik.messageid) then do
          if messindx.ik.password=' '  then leave /* no password */
          vpassword=doencrypt(vars.password)
          if messindx.ik.password=vpassword then do
              messindx.ik.expired=1
              eek=rewrite_messagebox(nummess,thefile,1)
              return eek
           end
           else do
                leave
           end  /* Do */
       end
     end          /*do */
/* if here, could not delete this message */
     eek=responseff('forbid',' could not be honored. You are not allowed to delete message:'||messindx.ik.subject ,tempfile,servername)
     return eek

   end                 /* when */

   when vars.messageid=0 then do        /* show abstracts of ALL messages */
       call lineout tempfile,' <hr> <h3> <center> Messages in this list: ' nummess_ok ' </center> </h3>  '
       messindx.order=0
       wow=write_thread(' ',1)   /* ' ' signals: all threads */
       call lineout tempfile,' <hr> '
       if vars.form<>' ' then do
           call lineout tempfile,' <li> Do you want to  <a href="'||vars.form||'">add a message?</a>'
       end
   end

   otherwise do                 /* show a particular message */
     eek=0
     do ido=1 to nummess
        if messindx.ido.messageid=vars.messageid then do
              aa=write_block(ido,0,'<br>')      /* write messaged indeed by nmu */
              eek=1
              leave
        end
     end   /* 1 to nummess */
     IF EEK=0 THEN DO
         foo=no_messageid()
         return foo
     END
   end           /* otherwise */

end             /* select */


talmost_done:
nop                /* jump here after messindx. only display */
call lineout tempfile,'<hr>  '
call lineout tempfile,'</body> </html> '
call lineout tempfile

aa=do_fixexpire(tempfile)
return 'FILE erase  TYPE text/html nocache NAME '||tempfile

if dodelete=1  then
   eek0=rewrite_messagebox(nummess,thefile,0)

if refresh_idx=1 then do
   foo=cvwrite(theidx,messindx)
   if foo=0 then
      say " Warning: could not write message index file:" theidx
end  /* Do */

return eek0

/********************************/
no_messageid:procedure expose tempfile

 call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'

  call lineout tempfile, "<html><head><title>Messages can not be found</title></head>"
  call lineout tempfile, "<body>"
  call lineout tempfile, "<h2>Could not find requested message </h2>"
  call lineout tempfile,' The requested message could not be found.'
  call lineout tempfile, "<hr></body></html>"
  call lineout tempfile

  return 'FILE ERASE TYPE text/html nocache NAME '||tempfile



/********************************/
/* encrypt a string */
doencrypt:procedure expose enmadd host_nickname
parse  arg  apass
/*de encrypt password */
  boop=get_value('MESSAGE_SCRAMBLE')
  If boop=' ' then boop=1234
  pt1=space(upper(strip(packur(apass))),0)
  do mm=1 to length(pt1)
      achar=substr(pt1,mm,1)
        achar=c2d(achar)
         boop=(boop*achar)//1000000
    end
 RETURN(BOOP)


/**********************************/
/* parse out list into vars. stem variable */
parse_vars:procedure expose vars.
parse arg list

jj=0
vars.messagebox='ANYONE'
vars.messageid=0
vars.listall=0
vars.fieldlist=' '
vars.fieldlistonly=0
vars.form=' '  ; vars.password=' ' ; vars.deleteme=0
vars.doabstract=0
vars.abstractlength=100
do until list=""
   parse var list a1 '&' list
   jj=jj+1
   parse var a1  a2 '=' a3
   a3=strip(packur(translate(a3,' ','+')))
   a2=strip(upper(a2))
   if wordpos(a2,'MESSAGE-BOX MESSAGE_BOX MESSTYPE MESSBOX ')>0 then do
      vars.messagebox=a3
      iterate
   end  /* Do */
   if wordpos(a2,'MESSAGE_ID MESSAGE-ID MESSAGEID ')>0 then do
        vars.messageid=a3
       iterate
   end  /* Do */
   if a2='THREAD_ID' | a2='THREAD-ID' then do
        vars.threadid=a3
        iterate
   end  /* Do */
   if a2="ABSTRACT_LENGTH" | a2="ABSTRACT_LENGTH" then do
         vars.abstractlength=a3
         iterate
   end  /* Do */
  
   if a2='FIELD_LIST_ONLY'| a2='FIELDS_ONLY' then do
        if wordpos(a3,'YES Y 1')>1 then
            a3=1
        else
            a3=0
        vars.fieldlistonly=a3
        iterate
   end  /* Do */
   if wordpos(a2,'LISTALL LIST-ALL LIST LIST_ALL') then do
      vars.listall=1
       iterate
   end  /* Do */
   if a2="FORM" | a2="FORM_NAME" | a2="FORMNAME" | a2="FORM-NAME" then do
      vars.form=a3
      iterate
   end  /* Do */
   if a2="DELETE_MESSAGE" | a2="DELETE-MESSAGE"  then do
      vars.deleteme=1
      iterate
   end
   if a2='PASSWORD' | a2='KEY' then do
        vars.password=a3
        iterate
   end  /* Do */
   if a2='ABSTRACT'  then do
      if wordpos(strip(upper(a3)),'YES Y 1')>0 then
            a3=1
        else
            a3=0
      vars.doabstract=a3
      iterate
   end
   if a2='FIELD_LIST' | a2='FIELD' then do
        if wordpos(strip(upper(packur(a3))),'CONTENTS CONTENT MESSAGE')>0 then
                a3='CONTENTS'
        vars.fieldlist=vars.fieldlist||' '||a3
        iterate
   end  /* Do */
/* otherwise */
   vars.a2=a3
end /* do */

vars.fieldlist=upper(translate(vars.fieldlist,' ','+'||'000d0a09'x))
if datatype(vars.abstractlength)<>'NUM' then vars.abstractlength=100
return 0


/***********************************/
/*------- Write a header, copying from message box file */
write_out_header:procedure 
parse arg thefile,header_end,tempfile
/* write header */
 if header_end=0  then    do      /* generic header needed? */
      call lineout tempfile,' <h1> This is the  ' vars.messagebox ' message box. </h1>'
  end
  else do
     do mm0=1 to header_end-1
         if mm0=1 then 
            tupid=linein(thefile,1)
         else
            tupid=linein(thefile)
         call lineout tempfile,tupid
     end
  end
  return 0


/*****************************/
/* rewrite message box, using info in messindx.
In particular, if messindx.i.expired=1; then either zap it,
or write minimal info (enough to maintain thread tree( */

rewrite_messagebox:procedure expose messindx. header_end filelines. tempfile ,
                       vars. messbox_dir  seperator dodelete order_list.

parse arg nummess,thefile,respond1

/* lock thefile (prevent changes */
aa=sref_open_read(thefile,30,'WRITE')

if aa<0  then  do
    say " could not open " thefile
    signal yukx
end
/* create a temporary file */
tmp1=dostempname(messbox_dir||"\a???????.TMP")
diddel=0
do mm=1 to header_end-1
   call lineout tmp1,filelines.mm
end

/* create indicators for 0=delete, 1=stub, 2= retain */
do mm=1 to nummess
   keepstatus.mm=2      /* default is to retain */
   if messindx.mm.expired=1 then do  /* delete me -- but maybe leave branch? */
       keepme=0
       chk1=messindx.mm.messageid   /* if ANY threadis of this value, retain stub */
       do mmj=mm+1 to nummess
            if messindx.mmj.threadid=chk1 & messindx.mmj.expired=0 then do
                keepme=1
                leave
            end  /* Do */
       end
       keepstatus.mm=keepme
       if keepme=0 then diddel=diddel+1
   end                  /* if expire */
end  /* Do  nummess*/


/* now write out message, stub, or skip */
do mm=1 to nummess
   if keepstatus.mm=0 then iterate      /* deleted ! */
   call lineout tmp1, seperator
   if keepstatus.mm=1 then do 
        call lineout tmp1,'Message-id: 'messindx.mm.messageid
        if messindx.mm.threadid<>'' then
             call lineout tmp1,'Thread-id: ' messindx.mm.threadid
        if messindx.mm.subject<>' '  then
             call lineout tmp1,'Subject: ' messindx.mm.subject
        call lineout tmp1,'expired: '
        iterate
   end  /* Do */
   do mm2=messindx.mm.1 to messindx.mm.2                      /* eelse, write out message as is */
      call lineout tmp1,filelines.mm2
   end /* do */
end

call lineout tmp1
aa=stream(thefile,'c','close')          /* unlock, delete, rewrite */
aa=dosdel(thefile)
if aa=0 then  do
  say " could not delete " thefile
  signal yukx
end

aa=dosrename(tmp1,thefile)
if aa=0 then do
  say " could not rename " tmp1 thefile
  signal yukx
end

/* if here, success */

  if respond1=1 then do
     call lineout tempfile, "<html><head><title>Message Deleted</title></head>"
     call lineout tempfile, "<body>"
     call lineout tempfile, "<h2>Message deleted </h2>"
     call lineout tempfile, diddel " messages were deleted from " vars.messagebox
     call lineout tempfile, "<hr></body></html>"
     call lineout tempfile
     return 'FILE ERASE TYPE text/html nocache NAME '||tempfile
   end
   else do
       if verbose>0 then say  diddel " messages were deleted from " vars.messagebox
   end  /* Do */
   return 0


yukx:   /* problem */
  call lineout tempfile, "<html><head><title>Messages Can Not Be Deleted</title></head>"
  call lineout tempfile, "<body>"
  call lineout tempfile, "<h2>Could not delete a message </h2>"
  call lineout tempfile, " The " vars.messagebox " message box is busy. Try again later"
  call lineout tempfile, "<hr></body></html>"
  call lineout tempfile
  return 'FILE ERASE  TYPE text/html nocache NAME '||tempfile


/* ********************************************************** */
/* write all messages which match threadid.
   After writing one of these messages, look for all other messages
   that match whose thread_id matches the messages's message_id
   The notion is that every message is the potential head of a
   thread with id=message_id, as well as being in the
   thread_id thread.
   This is a recursive program!

*/
write_thread:procedure expose messindx. filelines. tempfile vars. URI nummess dodelete order_list.
parse arg dothread,startat

/* startat is where lowest numbered message block to read from */
if startat=' ' then startat=1
ndid=0
/* Note: blank dothread is wildcard */
do wow=startat to nummess
   if messindx.wow.wrote=1 then iterate /* ignore if it's been written */
   if dothread=' ' | messindx.wow.threadid==dothread then do
       ndid=ndid+1
       if ndid=1 & dothread<>' ' then call lineout tempfile,'<ul> '
       if dothread=' ' then
          elem='<p> <img src="/imgs/redball.gif" alt="*" height=10 width=12> &nbsp '
       else
           elem='<li>'
       if messindx.wow.expired=0 then     /* if expired, don't display */
           foo=write_block(wow,1,elem)
        else
           foo=write_block(' ',-1,elem,messindx.wow.subject)
       fos=messindx.order
       messindx.order=fos+1
       messindx.wow.order=fos+1
       messindx.wow.wrote=1
       foo=write_thread(messindx.wow.messageid,wow+1)
    end
end /* do */
if ndid>0 & dothread<>' ' then call lineout tempfile,'</ul>'

return ndid


/* ********************************************************** */
/* similar to write_thread, but just determine order of appearance
in discussion list
*/

determine_order:procedure expose messindx. filelines. tempfile vars. URI nummess dodelete order_list.
parse arg dothread,startat

/* startat is where lowest numbered message block to read from */
if startat=' ' then startat=1
if startat=1 then messindx.order=0
/* Note: blank dothread is wildcard */
do wow=startat to nummess
   if messindx.wow.order>0 then iterate /* ignore if it's been written */
   if dothread=' ' | messindx.wow.threadid==dothread then do
       fos=messindx.order
       messindx.order=fos+1
       messindx.wow.order=fos+1
       foo=determine_order(messindx.wow.messageid,wow+1)
    end
end /* do */

/* if first call, then create the order_list stem var */
if startat=1  then do
  do ll=1 to nummess            /* create an ordered list */
     yos=messindx.ll.order
     order_list.yos=ll
  end /* do */
end  /* Do */

return  messindx.order

/* ************************ */
/*  Read a message block, parse it, and write to tempfile */
write_block:procedure expose messindx. filelines. tempfile vars. URI dodelete order_list.
 
parse arg nthm,doshort,sepelem,bsubject
isname=' '; isdate=' ' ; issubject=' ' ; isid=' ' ; thread_id=' '
aline=' ' ;nn=0 ; conton2=0 ; conton=0 ;skipme=0 ; isorig=' ';pass_word=' '
messfields.0=' ' ; aduration=' '
if doshort=' ' then doshort=0
thread_subject=' '

if doshort=-1 then do           /* put a deleted record placeholder */
      call lineout tempfile,sepelem nthm bsubject
      return 1
end  /* Do */

if messindx.fromindex=1 then do
   issubject=messindx.nthm.subject
   isdate=messindx.nthm.putdate
   isname=messindx.nthm.myname
   message_id=messindx.nthm.messageid
   anabstract=messindx.nthm.abstract
   anabstract=sref_replacestrg(anabstract,'<','&lt;','ALL')
   anabstract=sref_replacestrg(anabstract,'>','&gt;','ALL')

end  /* read from index*/

else do          /* read from message box file */
  do mm =messindx.nthm.1 to messindx.nthm.2
    aline=filelines.mm
    parse var aline atype ':' avalue 
    atype=packur(atype) ;  ttype=strip(upper(atype))
    avalue=packur(avalue)
    select
      when conton=1 then do                     /* building text body */
          conton2=conton2+1
          incontent.conton2=aline
      end
      when ttype='THREAD_SUBJECT' | ttype='THREAD-SUBJECT' then thread_subject=avalue
      when ttype='NAME' | ttype='FROM' then do 
         isname=avalue
         if isname=' ' then isname='[n.a.]'
      end  /* Do */
      when ttype='SUBJECT' then  do
          issubject=avalue
          if issubject=' '  then issubject='[no subject]'
      end
      when ttype='DATE' then isdate=avalue
      when ttype='DURATION'  then aduration=avalue
      when ttype='PASSWORD' then pass_word=avalue
      when ttype='MESSAGE_ID' | ttype='MESSAGE-ID' then message_id=avalue
      when ttype='CONTENTS' | ttype="MESSAGE"  | ttype="CONTENT" then conton=1  /* rest of lines are body of message */
      when wordpos(ttype,'THREAD THREAD_ID THREAD-ID THREADID')>0 then thread_id=strip(avalue)
      when ttype='ORIGINATOR' then  isorig=strip(avalue)
      otherwise do
          messfields.ttype=avalue
          messfields.0=messfields.0||' '||atype
      end
    end  /* select */
  end
  if thread_subject=' ' then thread_subject=issubject
end


/* when here, got various message fields read */
/* 2 classes of display:
  1) If doshort=0
       All fields are displayed, unless a field_list_only argument
       is present (in which case only the date,subject,time, contents and
       fields mentioned in the field_list).  Note that abstract_length
       is not used (the entire message is diplayed).
 
  2) If doshort=1
        A sentence containing subject, name and date is displayed.
        Other stuff shown  depends on the presence of a
        field_list='a+b+c' argument. If present, fields a,b, c (etc.), if
        present in the message, will be shown.  Note that CONTENTS may be
        one of these a,b,c.  If so, the ABSTRACT_LENGTH number of characters
       is displayed
*/


  select
     when doshort=0 then do            /* all the message */
       isname2=isname
       preid=0 ; postid=0 ; preidth=0; postidth=0; preid1st=0
/* might need this "root" */
      foo1=pos('&MESSAGE_ID=',upper(uri))
      if foo1>0 then do
              foo2=pos('&',uri,foo1+1) ;
              if foo2=0 then foo2=length(uri)
              goose=1+foo2-foo1;
              burl=delstr(uri,foo1,goose)
          end
      else do
                burl=uri
      end

      if length(isname2)>30 then
            isname2=left(isname2,30)||" ..."

/* put some short jumps in */
       if order_list.doit2it=1 then do
           myspot=messindx.nthm.order
           istop=0
           if messindx.nthm.messageid=messindx.nthm.threadid | messindx.nthm.threadid=' ' then 
                istop=1

           do t1=myspot-1 to 1 by -1
                preat=order_list.t1
                if messindx.preat.expired=1 then iterate
                if preid==0 then do
                   preid=messindx.preat.messageid
                   presubj=messindx.preat.subject

                end
/* check for prior thread, or 1st message in current thread */
                if messindx.preat.threadid=messindx.preat.messageid | messindx.preat.threadid=' ' then do
/* is a "head of thread-- head of own thread? */
                    if istop=0 & preid1st=0 then do
                        preid1st=messindx.preat.messageid
                        presubj1st=messindx.preat.subject
                    end
                    else do
                      if preidth=0  then do
                         preidth=messindx.preat.messageid
                         presubj2=messindx.preat.subject
                      end
                    end
                end /* do */
                if preid<>0 & preidth<>0 then leave
           end
           do t1=myspot+1 to messindx.nmessages
                postat=order_list.t1
                if messindx.postat.expired=1 then iterate
                if postid=0 then do
                   postid=messindx.postat.messageid
                   postsubj=messindx.postat.subject
                end
                if messindx.postat.threadid=messindx.postat.messageid | messindx.postat.threadid=' ' then do
                    postidth=messindx.postat.messageid
                    postsubj2=messindx.postat.subject
                end /* do */
                if postid<>0 & postidth<>0 then leave
           end  /* Do */

           url1=burl||'&MESSAGE_ID='||preid
           url2=burl||'&MESSAGE_ID='||postid
           url1st=burl||'&MESSAGE_ID='||preid1st

           url1th=burl||'&MESSAGE_ID='||preidth
           url2th=burl||'&MESSAGE_ID='||postidth


          if preid>0 then do
             call lineout tempfile,' || <a href="/'||url1||'">Previous message </a> '
          end
          if postid>0 then do
             call lineout tempfile,' || <a href="/'||url2||'">Next message </a> '
          end
      end       /* doit2it */

      url=burl
      foo1=pos('&PRIOR=',upper(url))
      if foo1>0 then do
             foo2=pos('&',url,foo1+1) ;
             if foo2=0 then foo2=length(url)
             goose=1+foo2-foo1;
             url=delstr(url,foo1,goose)
       end
      curl=url||'&PRIOR='||time('S')
      if curl<>' ' then
              call lineout tempfile,' || <a href="/'||curl||'"> Rewrite messages </a>'

      call lineout tempfile,' || <a href="#moreopts"> More options... </a>'

      call lineout tempfile,' <hr width=300> <h3> <center> Message from: ' isname2 ' </center> </h3>'
      call lineout tempfile,' <strong> From: </strong> ' isname
      call lineout tempfile,' <br><strong> Date: </strong> ' isdate
      do jj1=1 to words(messfields.0)
            get1=strip(word(messfields.0,jj1)) ; tget=upper(get1)
            if vars.fieldlistonly=1 then do
                if wordpos(tget,vars.fieldlist)=0 then iterate
            end  /* Do */
            call lineout tempfile,'<br> <strong> ' get1 ' </strong>:'
            call lineout tempfile,messfields.tget
       end /* do */
       call lineout tempfile,' <br><strong> Subject: </strong> ' issubject
       if thread_subject <>' ' then do
            call lineout tempfile,' <br><font -1><strong> thread subject:</strong>' thread_subject ' </font>'
       end
 
/*      call lineout tempfile,' <br> Message Number = ' messindx.nthm.order */

       call lineout tempfile,' <blockquote> '
       do ji=1 to conton2
              if incontent.ji=' ' then incontent.ji='<p>'
              call lineout tempfile,incontent.ji '<br>'
       end /* do */
       call lineout tempfile,' </blockquote> '
       call lineout tempfile,' <hr width=200>'

/* ****************************** */
/* Now write a list of responses */

      call lineout tempfile,' <a name="moreopts">Do you want to ...</a> <menu>'
/* give several " jump to next message" options */
      if order_list.doit2it=1 then do
          if preid<>0 then do
             call lineout tempfile,'<li><a href="/'||url1||'">View previous message </a>  <em>(' presubj ')? </em>'
          end
          if postid<>0 then do
             call lineout tempfile,'<li><a href="/'||url2||'">View next message </a> <em> (' postsubj ')?</em>'
          end
          
          if preid1st<>0 then 
             call lineout tempfile,'<p><li><a href="/'||url1st||'">View first message in thread </a> <em> (' presubj1st ')?</em>'
          else 
             call lineout tempfile,'<p>'
        

          if preidth<>0 then do
             call lineout tempfile,'<li><a href="/'||url1th||'">View first message in previous thread </a> <em> (' presubj2 ')?</em>'
          end
          if postidth<>0 then do
             call lineout tempfile,'<li><a href="/'||url2th||'">View first message in next thread </a> <em> (' postsubj2 ')?</em>'
          end
          

      end       /* doit2it */

/* rewrite message list */
      if curl<>' ' then
          call lineout tempfile,'<br><li><a href="/'||curl||'"> Rewrite message list? </a> <br> '
      else
         call lineout tempfile,'<br>'             

/* allow poster to delete this message */
       if pass_word<>' ' then do
          call lineout tempfile,'<li> Delete this message? <menu> '
          call lineout tempfile,' <FORM ACTION="forum" METHOD="GET">'
          call lineout tempfile,' Enter the message-password:'
          call lineout tempfile,'<INPUT TYPE="password" NAME="password"  SIZE=10 MAXLENGTH=15>?'
          call lineout tempfile,'<INPUT TYPE="hidden" name="delete_message" VALUE="1">  '
          call lineout tempfile,'<INPUT TYPE="hidden" name="message_id" VALUE="'strip(message_id)'">  '
          call lineout tempfile,'<INPUT TYPE="hidden" name="messbox" value="'strip(vars.messagebox)'">'
          call lineout tempfile,'<INPUT TYPE="submit" VALUE="and delete the message">'
          call lineout tempfile,'</FORM> </menu>'
       end
 
/* e-mail to poster (if e-mail address was given */
       foox=wordpos('E-MAIL',upper(messfields.0))
       if foox>0 then do
              eek='E-MAIL'
             emadd=strip(messfields.eek)
             call lineout tempfile,' <li>Mail a response directly to '
           call lineout tempfile,' <a href="mailto:'||emadd||'"> ' isname '? </a> '
       end

/* respond to this message */
       if vars.form<>' ' then do
            tmp0=strip(issubject)
            tmp0=translate(tmp0,'+',' '||'00090a0d'x)
            tmp0=translate(tmp0,'26'x,'&')
            url=vars.form||'?thread-id='||strip(message_id)||'&subject='||tmp0
            tmp1=thread_subject ; if tmp1=' ' then tmp1=issubject
            tmp1=translate(strip(tmp1),'+',' '||'00090a0d'x)
            tmp1=translate(tmp1,'26'x,'&')
            url=url||'&thread-subject='||tmp1
            url='/'||strip(url,'l','/')
            call lineout tempfile,'<li> Submit a <a href="'||url||'"> response to this message </a>'
       end  /* Do */
       

/* add to this thread */
       if messindx.nthm.threadid=' ' ,
              | messindx.nthm.threadid=messindx.nthm.messageid then do
            nop
       end /* do */
       else do
         if vars.form<>' ' then do
            tmp1=thread_subject 
            if tmp1=' ' then tmp1=issubject
            tmp1=translate(strip(tmp1),'+',' '||'00090a0d'x)
            tmp1=translate(tmp1,'26'x,'&')
            url=vars.form||'?thread-id='||strip(thread_id)||'&subject='||tmp1
            url=url||'&thread-subject='||tmp1
            url='/'||strip(url,'l','/')
            call lineout tempfile,'<li> Submit a <a href="'||url||'"> a new message to this thread </a>'
         end  /* Do */
      end

/* go back to list of messages */
       call lineout tempfile,'</menu>'
  
     end
/* --------------- end of full message display code  */

     otherwise do              /* summary of message, with link to full text*/
        atab='09'x ;i50=min(vars.abstractlength,50)
        issubject2=issubject
        if length(issubject2)>i50 then issubject2=left(issubject2,i50)||" ..."
        isdate2=isdate
        if length(isdate2)>i50 then isdate2=left(isdate2,i50)||" ..."
        isname2=isname
        if length(isname2)>i50 then isname2=left(isname2,i50)||" ..."
        call lineout tempfile,sepelem

        url=strip(uri,'t','/')||'/'
        url=uri||'&message_id='||strip(message_id)
       call lineout tempfile,'<a href="'||url||'">' issubject2 '</a> '
       call lineout tempfile,' &nbsp; <b> ' isname2 '</b>'  atab '&nbsp; &nbsp; &nbsp; <em> '
       call lineout tempfile, isdate2 ' </em>  '

        if vars.doabstract=1  &  messindx.fromindex=1 then do
             call lineout tempfile,'<blockquote>  '
             call lineout tempfile,' <strong> Contents: </strong> '
             call lineout tempfile,anabstract
             call lineout tempfile,'</blockquote>'
             return 1
        end

/* display field_list elememts, if requested */
     if vars.fieldlist=' '  & vars.doabstract=0 then do
        call lineout tempfile,' <MENU></menu> '  /* seems to compact output */
        return 1  /* no fields, so all done */
     end

/* try writiing beginning of a some specific fields */
       call lineout tempfile,'<menu>'
       do jj=1 to words(messfields.0)  /* list of fields recived */
          afield=word(messfields.0,jj) ; tafield=upper(strip(afield))
          if tafield='MESSAGE' | tafield='CONTENTS' then iterate /* do below */
          if wordpos(tafield,vars.fieldlist)=0 then iterate
          bvalue=messfields.tafield
          if length(bvalue)>vars.abstractlength then
              bvalue=left(bvalue,vars.abstractlength)||' ...'
          call lineout tempfile,' <li><strong>' afield ': </strong> ' bvalue
       end /* do */
       if wordpos('CONTENTS',vars.fieldlist) + ,
          wordpos('MESSAGE',vars.fieldlist) + ,
          wordpos('CONTENT',vars.fieldlist)>0  | vars.doabstract=1 THEN DO

           call lineout tempfile,' <li><strong> Contents: </strong> '
           abst=''
           do ji=1 to conton2
              abst=abst||incontent.ji
              if length(abst)>vars.abstractlength then leave
           end /* do */
           if length(abst)>vars.abstractlength then
                abst=left(abst,vars.abstractlength)||' ...'
           abst=sref_replacestrg(abst,'<','&lt;','ALL')
           abst=sref_replacestrg(abst,'>','&gt;','ALL')
           call lineout tempfile,abst
        end     /* wordpos */
        call lineout tempfile,'</menu>'

     end    /* otherwise -- display abstract */

  end   /*select */
  return 1



/* ----------- */                                                        
/* get environment value, possibly host specific */                      
/* ------------ */                                                       
get_value: procedure expose enmadd host_nickname 
parse arg vname,hname0
if hname0=0 then 
        hname=' '
else                                                    
    hname=strip(host_nickname)                          

vname=strip(vname) ;
if hname<>' ' then do                                                    
   aval=value(enmadd||vname||'.'||hname,,'os2environment')               
   if aval<>' ' Then                                                     
        return aval                                                      
end                                                                      
aval=value(enmadd||vname,,'os2environment')                              
return aval                                                              



/*****************************************/
/* build index list to messages */
build_index:procedure expose messindx. filelines. seperator vars. dodelete 
parse arg mm,thefilesize
nummess=0 ; at1=mm+1 ; thread_id=' ' ; message_id=' ' ; apassword=' ';
aduration=1000000000
aname=' ' ; asubject=' ' ; adate=' '
aexpired=0 ; did_expire=0
incontents=0 ; acontents=' '

do mm1=mm+1 to filelines.0


  if strip(filelines.mm1)=seperator | mm1=filelines.0 then do  /* end of message = save stuff */

/* first, check for exipration */
      if aexpired=0 then do             /* but maybe it has now ? */
          d1=date('B')
          parse var adate btime bdate
          d2=dateconv(strip(bdate),'N','B')
          if datatype(STRIP(aduration))<>'NUM' | aduration=' ' then aduration=1000000
          if (d2+aduration)<d1 then do
             aexpired=1
             dodelete=1         /* signals need for cleanup */
         end  /* Do */
       end
       did_expire=did_expire+aexpired  /* includes already and just now expired */

       nummess=nummess+1

       messindx.nummess.1=at1
       messindx.nummess.2=mm1-1
       messindx.nummess.expired=aexpired
       messindx.nummess.threadid=thread_id
       messindx.nummess.messageid=message_id
       messindx.nummess.password=apassword
       messindx.nummess.duration=aduration
       if name=' '  then aname='[n.a.]'
       messindx.nummess.myname=aname
       messindx.nummess.putdate=adate
       messindx.nummess.abstract=acontents
       if asubject=' ' then asubject='[no subject]'
       messindx.nummess.subject=asubject
       messindx.nummess.wrote=0
       messindx.nummess.order=0
       at1=mm1+1
       thread_id=' ' ; message_id=' ' ; ASUBJECT=' ' ; aNAME=' ' ;adate=' '
       aexpired=0 ; 
       ADURATION=1000000 ; aPASSWORD=' ' ; incontents=0 ; acontents=' '

       iterate
   end

/* get more of the message, or some of contents, or skip*/
  if incontents=2  then iterate         /* no more index info in this */

  if  incontents=1 then do
     acontents=acontents||' '||strip(translate(filelines.mm1,' ','00090a0d'x))
     acontents=space(acontents,1)
     if length(acontents)>120 then do
        acontents=left(acontents,120)'...'; incontents=2
     end  /* Do */
     iterate
  end  /* Do */
  
   parse var filelines.mm1 af ':' av ; af=strip(upper(af)) 
 
   if thread_id=' ' then do
      if af='THREAD_ID' | af='THREAD-ID' | af='THREADID' then do
          thread_id=upper(strip(packur(av)))
      end
   end


   if af='MESSAGE_ID' | af='MESSAGE-ID' | af='MESSAGEID' then do
          message_id=upper(strip(packur(av)))
   end

   if af="PASSWORD" then do
           apassword=upper(strip(packur(av)))
    end  /* Do */
   if af="DURATION" then do
           aduration=upper(strip(packur(av)))
   end
   if af="SUBJECT" then do
           asubject=strip(packur(av))
   end  /* Do */
   if af="DATE" then do
        adate=upper(strip(packur(av)))
   end  /* Do */
   if af="EXPIRED" then do      /* no argument used */
        aexpired=1
   end
   if af="NAME" | af='FROM' then do
         aname=strip(packur(av))
   end  /* Do */

  if af='CONTENTS' | af="MESSAGE"  | af="CONTENT" then do  /* rest of lines are body of message */
      incontents=1
      acontents=strip(packur(av))
  end  /* Do */


end  /* Do */

oy1=nummess-did_expire
messindx.nmessages=nummess
messindx.nmessagesok=oy1
messindx.headerend=mm
messindx.filesize=thefilesize
return nummess oy1


/* Query client for authorization stuff.  */
ask_auth:procedure expose verbose  transaction servername host_nickname
PARSE ARG R1, R2
IF R2="" THEN
  AREALM=R1
ELSE
  AREALM=R2

'header add WWW-Authenticate: Basic Realm=<'||arealm|| '>'  /* challenge */
foo=responseff('unauth', "for realm " arealm " was not authorized",tempfile,servername)
return foo
 


/* return error, etc responses */

responseff:procedure
 parse arg  request,message,tempfile,servername

foo=value('SREF_PREFIX',,'os2environment')
if foo<>'' then do
    foo=sref_response(request,message,servername)
    return foo
end /* do */

/* else, 1.2 */
  select
    when request='badreq'   then use='400 Bad request syntax'
    when request='notfound' then use='404 Not found'
    when request='forbid'   then use='403 Forbidden'
    when request='unauth'   then use='401 Unauthorized'
    when request='notallowed' then use='405 Method not allowed'
    when request='notimplemented' then use='501 Not implemented'
    otherwise do
        use='406 Not acceptable'
        call pmprintf('weird response '|| request||' '|| message)
      end
    end  /* Add others to this list as needed */

  /* Now set the response and build the response file */
  'RESPONSE HTTP/1.0' use     /* Set HTTP response line */
  parse var use code text
  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
  call lineout tempfile, "<html><head><title>"text"</title></head>"
  call lineout tempfile, "<body><h2>Sorry...</h2>"
  call lineout tempfile, "<p>The request from your Web client: " message"."
  call lineout tempfile, "<hr><em>HTTP response code:</em>" code '['text']'
  call lineout tempfile, "<br><em>From web server at:</em>" servername
  call lineout tempfile, "<br><em>Running:</em>" server()
  call lineout tempfile, "</body></html>"
  call lineout tempfile  /* close */
  return 'FILE ERASE TYPE text/html NAME' tempfile



/****** Do the fix expire? */
do_fixexpire:procedure
parse arg tempfile

  foo=value('SREF_PREFIX',,'os2environment')  /* 1.3? then let sref_gos do it */
  if foo<>'' then return 0

  FIX_EXPIRE = get_value('FIX_EXPIRE')
   if FIX_EXPIRE>0 THEN do
      ncc=chars(tempfile)
      aa=stream(tempfile,'c','close')
      foo=expirefor(fix_expire,ncc)
   end
return 0


/* ----------------------------------------------------------------*/
/* Routine to create an "expires" response header from scratch.
   Assumes respons type 200,  encoding=binary, no message id
   Dates are GMT (assuming GMT offset works)
   Arguments are: 
     time offset (fraction of a day to add to the expires, default=.04)
     Content length  (default=0)
     mime type  (def= text/html)
     noauto header flag  (N or Y)  (default =  YES )
     message id (default: if Goserve is in TEST mode, compute a goserve TEST 
                style message ID: <yyyymmddhhmmss.port.transaction@serveraddr>
                If 0, then don't send.
(defaults are used if not provided)
*/

expirefor: 
  parse arg aoffset, alength,am1,adrop,message_id
  if am1="" then am1="text/html"
  if alengh="" then alength=0
  if aoffset="" then aoffset=0.04
  if message_id=' ' then do
        message_id=0
        tst=upper(extract('test'))
        if tst='ON' then do
          p1=date('s')
          p2=time('n') ; p2=delstr(p2,3,1); p2=delstr(p2,5,1)
          p3=extract('serverport')
          p4=extract('transaction')
          p5=extract('serveraddr')
          message_id='<'||p1||p2||'.'||p3||'.'||p4||'@'||p5||'>'
        end
  end


  adrop1=' '
   if adrop="" | abbrev(translate(adrop),'Y')=1 then adrop1="NOAUTO"
 
  'RESPONSE HTTP/1.0 200 OK EXPIRE OFFSET'     /* Set HTTP response line */
  'HEADER ' adrop1 ' ADD Server: ' server()
   thisdate=sref_new_gmt()' GMT '
   expdate=sref_new_gmt(aoffset)' GMT'
  'HEADER ADD Date: 'thisdate
   if message_id<>'0' then
        'HEADER ADD Message-ID: ' message_id
  'HEADER ADD Content-Type: ' am1
  'HEADER ADD Content-Length:' alength
  'HEADER ADD Expires:'expdate
  'HEADER ADD Content-Transfer-Encoding: binary '
return 0

